# Ricerca di coppie di quadrati e cubi separati da un "piccolo" gap
# by p.p. 19 ottobre 2021
lista = dict()
min_n = 2
max_n = 500000000
max_dist = 1000
for n in range(min_n,max_n+1):
    cubo = n*n*n
    if cubo > max_dist:
        m_min = int((cubo-max_dist)**0.5)
    else:
        m_min = 2
    m_max = int((cubo+max_dist)**0.5)+1
    for m in range(m_min,m_max):
        quadrato = m * m
        dist = cubo - quadrato
        if dist < 0:
            dist = -dist
        if (dist != 0) and not (dist > max_dist): 
            if dist not in lista:
                lista[dist] = [[cubo,quadrato]]
            else:
                lista[dist].append([cubo,quadrato])
print ()
max_llista = 0
tot_coppie = 0
for i in sorted(lista):
    llista = len(lista[i])
    tot_coppie += llista
    if llista > max_llista:
        max_llista, mdist = llista,i
    if llista == 1:
        x = "coppia"
    else:
        x = "coppie"
    print (i,"-->",llista,x)
    for j in lista[i]:
        print ("\t",f"{j[0]:,}".replace(',','.'),",",f"{j[1]:,}".replace(',','.'))
print ()
print ("massimo cubo testato:",f"{cubo:,}".replace(',','.'))
print ("trovate:",len(lista),"distanze non maggiori di",max_dist)
print ("per un totale di",tot_coppie,"coppie")
print ("massimo numero di coppie =",max_llista,", per distanza =",mdist)
print ()